Package org.apache.solr.client.solrj.request

## Class AbstractUpdateRequest

- java.lang.Object
- - org.apache.solr.client.solrj.SolrRequest<T>
  - - org.apache.solr.client.solrj.request.CollectionRequiringSolrRequest<UpdateResponse>
    - - org.apache.solr.client.solrj.request.AbstractUpdateRequest

All Implemented Interfaces:
  `Serializable`, `IsUpdateRequest`

Direct Known Subclasses:
  `ContentStreamUpdateRequest`, `MultiContentWriterRequest`, `StreamingUpdateRequest`, `UpdateRequest`

    public abstract class AbstractUpdateRequest
    extends CollectionRequiringSolrRequest<UpdateResponse>
    implements IsUpdateRequest

See Also:
  Serialized Form

### Nested Class Summary

Nested Classes
`static class` `AbstractUpdateRequest.ACTION`

### Nested classes/interfaces inherited from class org.apache.solr.client.solrj.SolrRequest

`SolrRequest.ApiVersion, SolrRequest.METHOD, SolrRequest.SolrClientContext, SolrRequest.SolrRequestType`

### Field Summary

Fields
`protected int` `commitWithin`
`protected ModifiableSolrParams` `params`

### Fields inherited from class org.apache.solr.client.solrj.SolrRequest

`SUPPORTED_METHODS, useBinaryV2, usev2`

### Constructor Summary

Constructors
`AbstractUpdateRequest​(SolrRequest.METHOD m, String path)`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected UpdateResponse` `createResponse​(SolrClient client)` Create a new SolrResponse to hold the response from the server
`AbstractUpdateRequest.ACTION` `getAction()`
`int` `getCommitWithin()`
`ModifiableSolrParams` `getParams()`
`String` `getRequestType()` This method defines the type of this Solr request.
`boolean` `isSendToLeaders()` Indicates if clients should make attempts to route this request to a shard leader, overriding typical client routing preferences for requests.
`boolean` `isWaitSearcher()`
`AbstractUpdateRequest` `rollback()`
`AbstractUpdateRequest` `setAction​(AbstractUpdateRequest.ACTION action, boolean waitFlush, boolean waitSearcher)` Sets appropriate parameters for the given ACTION
`AbstractUpdateRequest` `setAction​(AbstractUpdateRequest.ACTION action, boolean waitFlush, boolean waitSearcher, boolean softCommit)`
`AbstractUpdateRequest` `setAction​(AbstractUpdateRequest.ACTION action, boolean waitFlush, boolean waitSearcher, boolean softCommit, int maxSegments)`
`AbstractUpdateRequest` `setAction​(AbstractUpdateRequest.ACTION action, boolean waitFlush, boolean waitSearcher, int maxSegments)`
`AbstractUpdateRequest` `setAction​(AbstractUpdateRequest.ACTION action, boolean waitFlush, boolean waitSearcher, int maxSegments, boolean expungeDeletes)`
`AbstractUpdateRequest` `setAction​(AbstractUpdateRequest.ACTION action, boolean waitFlush, boolean waitSearcher, int maxSegments, boolean softCommit, boolean expungeDeletes)`
`AbstractUpdateRequest` `setAction​(AbstractUpdateRequest.ACTION action, boolean waitFlush, boolean waitSearcher, int maxSegments, boolean softCommit, boolean expungeDeletes, boolean openSearcher)`
`AbstractUpdateRequest` `setCommitWithin​(int commitWithin)`
`void` `setParam​(String param, String value)`
`void` `setParams​(ModifiableSolrParams params)` Sets the parameters for this update request, overwriting any previous
`AbstractUpdateRequest` `setSendToLeaders​(boolean sendToLeaders)`
`void` `setWaitSearcher​(boolean waitSearcher)`

### Methods inherited from class org.apache.solr.client.solrj.request.CollectionRequiringSolrRequest

`requiresCollection`

### Methods inherited from class org.apache.solr.client.solrj.SolrRequest

`addHeader, addHeaders, getApiVersion, getBasePath, getBasicAuthPassword, getBasicAuthUser, getCollection, getContentStreams, getContentWriter, getHeaders, getMethod, getPath, getPreferredNodes, getQueryParams, getResponseParser, getStreamingResponseCallback, getUserPrincipal, process, process, setBasePath, setBasicAuthCredentials, setMethod, setPath, setPreferredNodes, setQueryParams, setResponseParser, setStreamingResponseCallback, setUseBinaryV2, setUserPrincipal, setUseV2`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### params

    protected ModifiableSolrParams params

#### commitWithin

    protected int commitWithin

### Constructor Detail

#### AbstractUpdateRequest

    public AbstractUpdateRequest​(SolrRequest.METHOD m,
                                 String path)

### Method Detail

#### setAction

    public AbstractUpdateRequest setAction​(AbstractUpdateRequest.ACTION action,
                                           boolean waitFlush,
                                           boolean waitSearcher)

Sets appropriate parameters for the given ACTION

#### setAction

    public AbstractUpdateRequest setAction​(AbstractUpdateRequest.ACTION action,
                                           boolean waitFlush,
                                           boolean waitSearcher,
                                           boolean softCommit)

#### setAction

    public AbstractUpdateRequest setAction​(AbstractUpdateRequest.ACTION action,
                                           boolean waitFlush,
                                           boolean waitSearcher,
                                           int maxSegments)

#### setAction

    public AbstractUpdateRequest setAction​(AbstractUpdateRequest.ACTION action,
                                           boolean waitFlush,
                                           boolean waitSearcher,
                                           boolean softCommit,
                                           int maxSegments)

#### setAction

    public AbstractUpdateRequest setAction​(AbstractUpdateRequest.ACTION action,
                                           boolean waitFlush,
                                           boolean waitSearcher,
                                           int maxSegments,
                                           boolean softCommit,
                                           boolean expungeDeletes)

#### setAction

    public AbstractUpdateRequest setAction​(AbstractUpdateRequest.ACTION action,
                                           boolean waitFlush,
                                           boolean waitSearcher,
                                           int maxSegments,
                                           boolean expungeDeletes)

#### setAction

    public AbstractUpdateRequest setAction​(AbstractUpdateRequest.ACTION action,
                                           boolean waitFlush,
                                           boolean waitSearcher,
                                           int maxSegments,
                                           boolean softCommit,
                                           boolean expungeDeletes,
                                           boolean openSearcher)

#### rollback

    public AbstractUpdateRequest rollback()

Since:
  Solr 1.4

#### setParam

    public void setParam​(String param,
                         String value)

#### setParams

    public void setParams​(ModifiableSolrParams params)

Sets the parameters for this update request, overwriting any previous

#### getParams

    public ModifiableSolrParams getParams()

Specified by:
  `getParams` in class `SolrRequest<UpdateResponse>`

#### createResponse

    protected UpdateResponse createResponse​(SolrClient client)

Description copied from class: `SolrRequest`
Create a new SolrResponse to hold the response from the server

Specified by:
  `createResponse` in class `SolrRequest<UpdateResponse>`
Parameters:
  `client` - the `SolrClient` the request will be sent to

#### getRequestType

    public String getRequestType()

Description copied from class: `SolrRequest`
This method defines the type of this Solr request.

Specified by:
  `getRequestType` in class `SolrRequest<UpdateResponse>`

#### isWaitSearcher

    public boolean isWaitSearcher()

#### getAction

    public AbstractUpdateRequest.ACTION getAction()

#### setWaitSearcher

    public void setWaitSearcher​(boolean waitSearcher)

#### getCommitWithin

    public int getCommitWithin()

#### setCommitWithin

    public AbstractUpdateRequest setCommitWithin​(int commitWithin)

#### isSendToLeaders

    public boolean isSendToLeaders()

Description copied from interface: `IsUpdateRequest`
Indicates if clients should make attempts to route this request to a shard leader, overriding typical client routing preferences for requests. Defaults to true.

Specified by:
  `isSendToLeaders` in interface `IsUpdateRequest`
See Also:
  `CloudSolrClient.isUpdatesToLeaders()`

#### setSendToLeaders

    public AbstractUpdateRequest setSendToLeaders​(boolean sendToLeaders)